from selenium import webdriver
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.chrome.options import Options
from selenium.webdriver.chrome.service import Service
import time
from bs4 import BeautifulSoup
import csv
import pandas as pd
import pyperclip
import time
import pickle
from selenium.webdriver.support import expected_conditions as EC
from selenium.common.exceptions import NoSuchElementException, TimeoutException, StaleElementReferenceException
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.common.by import By
import itertools

options = webdriver.ChromeOptions()
# options.add_argument("headless")  # 필요시 헤드리스 모드 활성화

service = Service('chromedriver.exe')
driver = webdriver.Chrome(service=service, options=options)
wait = WebDriverWait(driver, 2)
counter = itertools.count(start = 1)

# URL 설정
url = "https://nid.naver.com/nidlogin.login?mode=form&url=https://www.naver.com/"
driver.get(url)

nid = ''
npw = ''

# 무한 루프 방지용 변수
login_success = False

while not login_success:
    try:
        # 아이디 입력
        time.sleep(1)  # 페이지 로딩 대기
        pyperclip.copy(nid)
        driver.find_element(By.CSS_SELECTOR, '#id').send_keys(Keys.CONTROL + 'v')
        
        # 비밀번호 입력
        time.sleep(1)
        pyperclip.copy(npw)
        driver.find_element(By.CSS_SELECTOR, '#pw').send_keys(Keys.CONTROL + 'v')

        # 로그인 버튼 클릭
        driver.find_element(By.XPATH, '//*[@id="log.login"]').click()
        
        # 로그인 성공 여부 확인
        time.sleep(2)  # 로그인 처리 대기
        if driver.current_url == "https://www.naver.com/":  # 성공적으로 로그인한 경우
            print("로그인 성공")
            login_success = True  # 로그인 성공
        else:
            print("로그인 실패. 다시 시도합니다.")
            driver.get(url)  # 로그인 페이지로 돌아가기

    except Exception as e:
        print("오류 발생:", e)
        break  # 오류 발생 시 루프 종료

lists_id = []
data = pd.read_csv(f'naver_blogId_교육.csv', encoding = "ISO=8859-1")
msg = "안녕하세요! 저는 블로거 태지쌤입니다. 관심사가 비슷한 것 같아 서이추 드립니당~~~ 이웃 추가해주시면 감사드리겠습니다. 즐거운 하루 되세요! - 태지쌤 드림"

for i in data:
    for j in range(len(data)):
        lists_id.append(data[i][j])
s = set(lists_id)
sorted_list_id = list(s)
for i in range(len(sorted_list_id)):
# for i in range(0, 100):
    try:
        blog_url = "http://m.blog.naver.com/BuddyAddForm.naver?blogId=" + sorted_list_id[i] + "&returnUrl=https%253A%252F%252Fm.blog.naver.com%252F"
        driver.get(blog_url)

        exceptional_text = WebDriverWait(driver, 3).until(
            EC.presence_of_element_located((By.CLASS_NAME, 'dsc'))
        ).text
        
        if "진행중" in exceptional_text or "제한된" in exceptional_text:  # 신청 진행 중인 경우
            print("이미 이웃 신청이 진행 중입니다. 다음으로 넘어갑니다.")
            continue

        checkbox = WebDriverWait(driver, 3).until(
            EC.element_to_be_clickable((By.XPATH, '//label[contains(text(), "서로이웃")]/preceding-sibling::input'))
        )
        if not checkbox.is_enabled(): 
            print("서로이웃 추가가 불가능하여 다음으로 넘어갑니다.")
            continue

        checkbox.click()  # 체크박스 클릭
        print("서로이웃 체크박스 클릭 완료")

        driver.find_element(By.TAG_NAME, 'textarea').clear()
        driver.find_element(By.TAG_NAME, 'textarea').send_keys(msg)
        driver.implicitly_wait(5)
        print("메세지 작성 완료")

        driver.find_element(By.CLASS_NAME, 'btn_ok').click()
        print(f"{next(counter)}번째 서이추 완료!")
        driver.implicitly_wait(10)

    except Exception as e:
        print(f"Error: {e} - {sorted_list_id[i]}에 대한 이웃 추가 실패, 다음으로 넘어갑니다.")
        continue

driver.quit()
